#!/usr/bin/perl -w
# Getlikes 1.0
# Processes the likelihood scores files generated during a sliding window
# analysis using Likewind 1.0

#define whether this will be a multiple file processing job or not
    print "How many datasets will you be processing -- default=1?:\n";
    $multipleopt=<STDIN>;
    chomp $multipleopt;
    if (! $multipleopt) {
    $multipleopt=1
  }
while ($multipleopt =~ m/\D+/) {
    print "Doooh! Letters are not appropriate answers. How MANY datasets
will you be processing? (hint: enter a number or hit return for default=1):\n";
    $multipleopt=<STDIN>;
    chomp $multipleopt;
    if (! $multipleopt) {
    $multipleopt=1;
}
  }

#define switch for full versus root name request
    if ($multipleopt==1) {
    $fullroot = "full";
    }
    else {
    $fullroot = "root";
    }

#define starting number for filename
if ($multipleopt !=1) {
    print "What is the starting number for your simulation files -- default=1?:\n";  
    $simnum=<STDIN>;
    chomp $simnum;
    if (! $simnum) {
    $simnum=1;
    }
  }
else {
    $simnum=1;
  }
#define how many scores files
    print "How many scores files (2 or 3)?\n";
    $scorefilenumber=<STDIN>;
    chomp $scorefilenumber;

#define the full dataset scores filenames
    print "Enter the ${fullroot} name of the full dataset tree scores file:
(default ${fullroot} name = allsites.scores)\n";
    $allsitesname=<STDIN>;
    chomp $allsitesname;
    if (! $allsitesname) {
    $allsitesname="allsites.scores";
  }

#define the pos12 scores filename
if ($scorefilenumber==3) {
    print "Enter the ${fullroot} name of the positions \"1&2\" tree scores file:
(default ${fullroot} name = allsites.scores)\n";
    $pos12sitesname=<STDIN>;
    chomp $pos12sitesname;
    if (! $pos12sitesname) {
    $pos12sitesname="pos12.scores";
  }
  }

#define best tree for each window scores file
    print "Enter the ${fullroot} name of the best tree for each window scores files:
(default ${fullroot} name = besttre.scores)\n";
    $besttreename=<STDIN>;
    chomp $besttreename;
    if (! $besttreename) {
    $besttreename="besttre.scores";
  }


for ($simcounter = $simnum; $simcounter < $multipleopt + $simnum; $simcounter++) {

    if ($multipleopt==1) {
    $allscountername=$allsitesname;
  }
    else {
    $allscountername="${simcounter}\.${allsitesname}";
}
    open(ALLSITESLIKE, "${allscountername}");   
    @allsiteslike=<ALLSITESLIKE>;
    close(ALLSITESLIKE);

if ($scorefilenumber==3) {
      if ($multipleopt==1) {
      $pos12countername=$pos12sitesname;
      } 
    else {
    $pos12countername="${simcounter}\.${pos12sitesname}";
  }
    open(POS12SITESLIKE, "${pos12countername}");   
    @pos12siteslike=<POS12SITESLIKE>;
    close(POS12SITESLIKE);    
  }
    if ($multipleopt==1) {
    $bestcountername=$besttreename;
  }
    else { 
    $bestcountername="${simcounter}\.${besttreename}";
}
    open(BESTTREELIKE, "${bestcountername}");
    @besttreelike=<BESTTREELIKE>;
    close(BESTTREELIKE);

#strip the log-likelihoods out of the scores files

    @allsiteslikeclean = grep { s/\d\s+(\d+\.\d+)/$1/ } @allsiteslike;
    @besttreelikeclean = grep { s/\d\s+(\d+\.\d+)/$1/ } @besttreelike;
if ($scorefilenumber==3) { 
    @pos12siteslikeclean = grep { s/\d\s+(\d+\.\d+)/$1/ } @pos12siteslike;
}    

    if ($multipleopt==1) {
    open(ALL, ">all");
foreach $element (@allsiteslikeclean) {
print ALL "$element";}
    close(ALL);
    open(BEST, ">best");
foreach $element1 (@besttreelikeclean) {
print BEST "$element1";}
    close(BEST);
if ($scorefilenumber==3) { 
    open(POS12, ">pos12");
foreach $element2 (@pos12siteslikeclean) {
print POS12 "$element2";}
    close(POS12);
}
}
#subtracting likelihoods and creating delta LnL files for allsites analysis
    $number=@besttreelikeclean;
    $number=$number-1;
for ($counter=0; $counter<=$number; $counter++) {
  $diff1=@allsiteslikeclean[${counter}] - @besttreelikeclean[${counter}];
  $difftrunc=sprintf("%13.8f\n", $diff1);
  push @diffs1, "$difftrunc";
}
@difftrunclean= grep { s/^\s+(\S+\.\d+)/$1/ } @diffs1;

open (DIFFS1, ">${simcounter}\.allbest.deltalnL");
foreach $element4 (@difftrunclean) {
print DIFFS1 "$element4";
}
close (DIFFS1);

#subtracting likelihoods and creating delta LnL files for pos12 analysis
if ($scorefilenumber==3) { 
    $number=@pos12siteslikeclean;
    $number=$number-1;
for ($counter=0; $counter<=$number; $counter++) {
  $diff2=@pos12siteslikeclean[${counter}] - @besttreelikeclean[${counter}];
  $difftrunc2=sprintf("%13.8f\n", $diff2);
  push @diffs2, "$difftrunc2";
}
@difftrunclean2= grep { s/^\s+(\d+\.\d+)/$1/ } @diffs2;

open (DIFFS2, ">${simcounter}\.pos12best.deltalnL");
foreach $element5 (@difftrunclean2) {
print DIFFS2 "$element5";
}
close (DIFFS2);
}

#sort deltas by descending numerical value

sub numerically { $b <=> $a; }
@sortedtrunclean = sort numerically @difftrunclean;
open(TOPVALUE, ">>top.allsites.deltalnLs");
$topvalue = shift @sortedtrunclean;
print TOPVALUE "$topvalue";
close(TOPVALUE);

  if ($scorefilenumber==3) {
  @sortedtrunclean2 = sort numerically @difftrunclean2;
  open(TOPVALUE2, ">>top.pos12.deltalnLs");
  $topvalue2 = shift @sortedtrunclean2;
  print TOPVALUE2 "$topvalue2";
  close(TOPVALUE2);
  }

}
if ($multipleopt==1) {
rename "${simnum}.allbest.deltalnL", "allbest.deltalnL";
 if ($scorefilenumber==3) {
 rename "${simnum}.pos12best.deltalnL", "pos12best.deltalnL";
}
}
exit 0;
