#!/usr/bin/perl -w
# Likewind 1.03
# This Perl program allows one to evaluate evidence for recombination 
# using a sliding window maximum likelihood approach using the PAUP* program.

#define the rootname
        print "Enter a name for your output file:\n";
#define the output filename variable
        $outfilename = <STDIN>;
        chomp $outfilename;
#create output file
        open(NEXUSOUT, ">$outfilename") || die "Cannot open output file: $!";
        print NEXUSOUT "#NEXUS\n\n";
#define variable for number of sites
	$nchar = 0;        
        while (! $nchar) {
        print "\nEnter the total number of characters in your alignment:\n";
        $nchar = <STDIN>;
	chomp $nchar;
}
#decide whether you want to use a user-defined tree or not
        print "\nDo you want to impose a user-defined tree (u) during window
analysis or estimate the tree(s) (e) from the full data 
-- (answer \"u\" or \"e\" --  default \"e\"):\n";
        $userdef=<STDIN>;
        chomp $userdef;
if ($userdef eq "u") {
        $usertree = 0;
        while (! $usertree) {
        print "\nEnter the name of your user-defined tree (in nexus format):\n";
	$usertree = <STDIN>;
	chomp $usertree;
      }
}
#decide whether to have user-defined branchlengths or not
        print "\nDo you want to enforce user-defined branchlengths\non window likelihood estimates (answer: \"y\" or \"n\" -- default=\"n\"):
(note: only applied to all sites trees):\n";
        $inblopt=<STDIN>;
        chomp $inblopt;
        if ($inblopt eq "y" || $inblopt eq "Y" || $inblopt eq "yes") {
        $blopt="yes";
      }
        else  { 
        $blopt="no";
      }
#decide whether to base analysis on codons or not
        if ($userdef ne "u") {    
          print "\nDo you want to deal with different codon positions \nand create codon position sets (\"y\" or \"n\" -- default=\"n\")?\n";
        $codonquery = <STDIN>;
        chomp $codonquery;
        $lastfirst = $nchar-2;
        chomp $lastfirst;
        $lastsecond = $nchar-1;
        chomp $lastsecond;
        if ($codonquery eq "y") {
            print NEXUSOUT "BEGIN CODONS;\n  CODONPOSSET * CodonPositions =\n     1: 1-${lastfirst}\\3,\n     2: 2-${lastsecond}\\3,\n     3: 3-${nchar}\\3 ${nchar};\nEND;\n\n";
	  }
        else { $codonquery = "n"; 
      }
      }
        else { $codonquery = "n"; 
      }
#define variable for window size
        print "\nEnter the width of the sliding window (default=100):\n";

        $userwind = <STDIN>;
        chomp $userwind;
        if (! $userwind) {

        $wind = 100;
}
        else {
        $wind = $userwind;
      }
#define variable for sliding window advancing increment
        print "\nEnter the sliding increment (default=10):\n";
	$userincr = <STDIN>;
        chomp $userincr;
        if (! $userincr) {
        $incr = 10;
}
        else {
        $incr = $userincr;
        }

#start writing assumptions block
        print NEXUSOUT "BEGIN PAUP;\n";
        print NEXUSOUT "log file=${outfilename}.window.log;\n";
        print NEXUSOUT "set autoclose=yes;\n";

#counting variable
	$counter=0;
#building the character sets from input data
        while (${nchar}-(${counter}*${incr}+${wind}) >= 0) {
        $charterm1=${counter}*${incr};
        $charterm2=${wind}+${charterm1}+1;
        $charsetname=${counter}.W;
        if  ($counter==0) {
        print NEXUSOUT "charset 0W = ${charterm2}-${nchar};\n";
}       elsif ($nchar== ($wind+$charterm1)) {
        print NEXUSOUT "charset ${charsetname} = 1-${charterm1};\n";
}
        else  {
        print NEXUSOUT "charset ${charsetname} = 1-${charterm1} ${charterm2}-${nchar};\n";
}
        $counter++;
}
        print "\n${counter} windows created and written to \"$outfilename\" \n";
        
#part 2 -- building the paup commands for estimating initial trees and parameters

        print "\nDo you want to build trees using full max-like (m)\nor distance (d) approximation? (answer: m or d, default=m):\n";
        $mldistquery = <STDIN>;
        chomp $mldistquery;
        if ($mldistquery eq "d") {
            $mldistswitch = 2;
      }
        else {
             $mldistswitch = 1;
	   }
#parameter estimation block for the analysis
 if ($userdef ne "u") {
	if ($codonquery eq "y") {
        print NEXUSOUT "\n[get the ML tree for 1+2 positions with fitted GTR+Invariable sites + Gamma model]
        exclude Pos3;
	set criterion = distance;
	DSet distance=JC objective=ME base=equal rates=equal pinv=0 subst=all negbrlen=setzero;
	NJ showtree=no breakties=random;
	set criterion=like;
	lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est pinv=est;  
	lset nst=6 base=previous rmat=previous rates=gamma shape=previous pinv=previous;\n";
	if ($mldistswitch==2) {
        print NEXUSOUT "     set criterion=distance;\n     dset distance=ml objective=ME;\n";
      }
 	print NEXUSOUT "       hsearch;
	savetrees brlens=yes format=nexus file=${outfilename}.pos12.tre;
        savetrees brlens=yes format=phylip file=${outfilename}.pos12.phy;

[get the ML tree for All 3 positions with fitted GTR+ Invariable sites + Gamma model]
	include all;
	DSet distance=JC objective=ME base=equal rates=equal pinv=0 subst=all negbrlen=setzero;
	NJ showtree=no breakties=random;
	set criterion=like;
	lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est pinv=est;
        lset nst=6 base=previous rmat=previous rates=gamma shape=previous pinv=previous;\n";
	if ($mldistswitch==2) {
        print NEXUSOUT "        set criterion=distance;\n        dset distance=ml objective=ME;\n";
      }
 	print NEXUSOUT "        hsearch;
	savetrees brlens=yes format=nexus file=${outfilename}.allsites.tre;
        savetrees brlens=yes format=phylip ${outfilename}.allsites.phy;\n";
}
        else {
        print NEXUSOUT "\n[get the ML tree for all positions with fitted GTR+ Invariable sites + Gamma model]
	DSet distance=JC objective=ME base=equal rates=equal pinv=0 subst=all negbrlen=setzero;
	NJ showtree=no breakties=random;
	set criterion=like;
	lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est pinv=est;  
	lset nst=6 base=previous rmat=previous rates=gamma shape=previous pinv=previous;\n";
	if ($mldistswitch==2) {
        print NEXUSOUT "        set criterion=distance;\n        dset distance=ml objective=ME;\n";
      } 
       
        print NEXUSOUT "        hsearch;
	savetrees brlens=yes format=nexus file=${outfilename}.allsites.tre;
        savetrees brlens=yes format=phylip file=${outfilename}.allsites.phy;\n";
}
}

else {  print NEXUSOUT "\n[get the ML parameters for the user-defined tree assuming a GTR+Invariable sites + Gamma model]
        gettrees storebrlens=yes file=${usertree};
        set criterion=like;
	lscores  1/ userbrlens=${blopt} nst=6  base=est  rmat=est  rates=gamma  shape=est pinv=est;
        lset nst=6 base=previous rmat=previous rates=gamma shape=previous pinv=previous;\n";
}       
        
#start running each window
	print NEXUSOUT "\n[sliding window analysis block]\n";
        $counter2 = 0;
        while ($counter2 < $counter) {
        $lastcounter = ${counter2}-1;
        $nextcounter = ${counter2}+1;
        print NEXUSOUT "[Iteration number ${nextcounter}]\n";
	  if (${counter2} == 0) {
          print NEXUSOUT "     exclude 0W;\n";
	}
         else {
          print NEXUSOUT "     include ${lastcounter}W;\n     exclude ${counter2}W;\n";
	}
          print NEXUSOUT "     set maxtrees=1000 increase=auto;\n     hsearch;\n";
          if (${counter2} == 0) {
          $repapvariable = "replace";
	}
          else { $repapvariable = "append";
	       }
          print NEXUSOUT "     lscores 1/ userbrlens=no scorefile=${outfilename}.besttre.scores ${repapvariable};\n";
          print NEXUSOUT "     cleartrees nowarn;\n";
          if ($userdef ne "u") { 
          if ($codonquery eq "y") {
          print NEXUSOUT "     gettrees storebrlens=yes file=${outfilename}.allsites.tre;
     lscores 1/ userbrlens=${blopt} scorefile=${outfilename}.allsites.scores ${repapvariable};
     cleartrees nowarn;	
     gettrees storebrlens=yes file=${outfilename}.pos12.tre;
     lscores 1/ userbrlens=no scorefile=${outfilename}.pos12.scores ${repapvariable};
     cleartrees nowarn;\n";	
}
 
          else {
         print NEXUSOUT "     gettrees storebrlens=yes file=${outfilename}.allsites.tre;
     lscores 1/ userbrlens=${blopt} scorefile=${outfilename}.allsites.scores ${repapvariable};
     cleartrees nowarn;\n";
}	
}
	  else {
	print NEXUSOUT "     gettrees storebrlens=yes file=${usertree};
     lscores 1/ userbrlens=${blopt} scorefile=${outfilename}.usertree.scores ${repapvariable};
     cleartrees nowarn;\n";
}
          $counter2++;
      }
        print NEXUSOUT "LOG STOP;\n\nEND;";
        print "\nEverything has now been written to \"$outfilename\"\n";
        close (NEXUSOUT);
#end program
        exit 0;


