#!/usr/bin/perl -w
#Making seq-gen sim files
print "Enter the number of simulations you want to do:\n";
$num=<STDIN>;
chomp $num;
print "Enter the number you would like to start naming the files with:\n";
$userin=<STDIN>;
chomp $userin;
print "Enter the filename of the tree (in PHYLIP format) that
you wish to simulate over:\n";
$treefile=<STDIN>;
chomp $treefile;
print "Enter the name of your likewind template file in this directory:\n";
$likewindfil=<STDIN>;
chomp $likewindfil;
print "Enter the six rate matrix parameters for the REV (GTR) model:
(use the same order as in a PAUP* \'rmatrix block\' file with each number separated by a single space)\n";
$rateparam=<STDIN>;
chomp $rateparam;
$rateparam=~ s/^\s+//;
$rateparam=~ s/\s+/,/g;
#print $rateparam;
print "Enter the 4 base frequency parameters:
(use the order A C G T (same as PAUP* or seq-gen) with each number 
separated by a single space)\n";
$freqparam=<STDIN>;
chomp $freqparam;
$freqparam=~ s/^\s+//;
$freqparam=~ s/\s+/,/g;
#print $freqparam;
print "Enter the gamma distribution shape parameter (alpha):\n";
$alpha=<STDIN>;
chomp $alpha;
print "Enter the proportion of invariable sites (Pinv):\n";
$pinvar=<STDIN>;
chomp $pinvar;

#determine the total length of the alignments
open(TEMPLATE, "${likewindfil}");
@template=<TEMPLATE>;
close(TEMPLATE);
$length=0;
$template= join('', @template);
if ($template=~ m/charset\s0W\s=\s\w+-(\w+)/) {
$length=$1;}
print $length;
if ($template=~ m/scorefile=(.*besttre).scores/) {
$besttre= $1;
}
print $besttre;
if ($template=~ m/scorefile=(.*allsites).scores/) {
$allsites= $1;
}
print $allsites;
#create simblock.template file for seq-gen to use
shift @template;
open(SIMTEMP, ">simblock.template");
print SIMTEMP @template;
close(SIMTEMP);
#create file to write output to.
open(SIMOUT, ">${likewindfil}.sim.out") || die "Can't open ${likewindfil}.sim.out: $!";

@simout=`seq-gen -mGTR -l${length} -n${num} -a${alpha} -i${pinvar} -r${rateparam} -f${freqparam} -on -xsimblock.template \< ${treefile}`;

$bigline= join('', @simout);
@newsimout =  split(/Begin DATA;/, ${bigline});  
$counter=$userin;
foreach $element (@newsimout) { 
		  if ($element=~m/${besttre}.scores/) { $element=~ s/${besttre}.scores/${counter}.${besttre}.scores/g;}
                  if ($element=~m/${allsites}.scores/) { $element=~ s/${allsites}.scores/${counter}.${allsites}.scores/g; $counter++;}                             ;}
grep s/(\s+\[Dataset\s\d+\])/Begin DATA;$1/, @newsimout;
grep s/(.window.log);/$1 replace;/, @newsimout;
grep s/(savetrees.*);/$1 replace=yes;/g, @newsimout;
grep s/(lscores.*)(nst=6\s+base=est.*;)/$1userbrlens=no $2/, @newsimout;
print SIMOUT @newsimout;

#close SIMOUT and write to multiblock
close(SIMOUT);
print "Done! Simblock outfile written to: ${likewindfil}.sim.out\n";
system("rm -f simblock.template");
#end program
exit 0;
